From: Jonatan Schlag <jonatan.schlag@ipfire.org>
To: network@lists.ipfire.org
Subject: [PATCH 3/3] dhcp: add hook_edit() function
Date: Fri, 14 Jul 2017 21:10:52 +0200 [thread overview]
Message-ID: <1500059452-3421-3-git-send-email-jonatan.schlag@ipfire.org> (raw)
In-Reply-To: <1500059452-3421-1-git-send-email-jonatan.schlag@ipfire.org>
[-- Attachment #1: Type: text/plain, Size: 1664 bytes --]
Basically we just read in the config,
parsing the passed command line options (so we set the new value for he passed options)
and writing the config back.
Signed-off-by: Jonatan Schlag <jonatan.schlag(a)ipfire.org>
---
src/hooks/configs/dhcp | 40 ++++++++++++++++++++++++++++++++++++++++
1 file changed, 40 insertions(+)
diff --git a/src/hooks/configs/dhcp b/src/hooks/configs/dhcp
index 8bb6aa9..98ef5e3 100644
--- a/src/hooks/configs/dhcp
+++ b/src/hooks/configs/dhcp
@@ -83,6 +83,46 @@ hook_new() {
exit ${EXIT_OK}
}
+hook_edit() {
+ local zone=${1}
+ local config=${2}
+ shift 2
+
+ if ! device_exists ${zone}; then
+ error "Zone '${zone}' doesn't exist."
+ exit ${EXIT_ERROR}
+ fi
+
+ local ${HOOK_CONFIG_SETTINGS}
+
+ # If reading the config fails we cannot go on
+ if ! zone_config_settings_read "${zone}" "${config}"; then
+ log ERROR "Could read the config ${config} for zone ${upl0}"
+ return ${EXIT_ERROR}
+ fi
+
+ if ! hook_parse_cmdline $@; then
+ # Return an error if the parsing of the cmd line fails
+ return ${EXIT_ERROR}
+ fi
+
+ # Check if the user disabled ipv4 and ipv6
+ if ! enabled ENABLE_IPV6 && ! enabled ENABLE_IPV4; then
+ log ERROR "You disabled IPv6 and IPv4. At least one must be enabled"
+ return ${EXIT_ERROR}
+ fi
+
+ local hook="${config//.[[:digit:]]/}"
+ local id="${config//"${hook}."/}"
+
+ if ! zone_config_settings_write "${zone}" "${hook}" ${id}; then
+ log ERROR "Could not write config settings file ${config} for ${zone}"
+ return ${EXIT_ERROR}
+ fi
+
+ exit ${EXIT_OK}
+}
+
hook_up() {
local zone=${1}
local config=${2}
--
2.6.3
next prev parent reply other threads:[~2017-07-14 19:10 UTC|newest]
Thread overview: 5+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-07-14 19:10 [PATCH 1/3] zone: fix zone_config() Jonatan Schlag
2017-07-14 19:10 ` [PATCH 2/3] header-zone: refactor hook_config_edit Jonatan Schlag
2017-07-14 23:56 ` Michael Tremer
2017-07-14 19:10 ` Jonatan Schlag [this message]
2017-07-15 0:53 ` [PATCH 3/3] dhcp: add hook_edit() function Michael Tremer
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1500059452-3421-3-git-send-email-jonatan.schlag@ipfire.org \
--to=jonatan.schlag@ipfire.org \
--cc=network@lists.ipfire.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox